//user:    GSC
//date:    28/12/2023
//ver:     4.6.0
//project: TEST 4.6.0
//type:    event trigger (TRIGGER DI CLASSE)
//class:   gwr_r_report_model
//note:    gwr_r_report_model event trigger

import org.springframework.core.env.Environment;
import com.geowebframework.transfer.objects.exception.*;
	

public class GwrRReportModelEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	private final String CLASS_NAME = "gwr_r_report_model";
	private final String CLASS_TABLE_NAME = CLASS_NAME;
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_report_model - beforeInsert()");
		
		Integer is_default = valuesMap.is_default;
		String cod_model = valuesMap.cod_model;
		String cod_report = valuesMap.cod_report;
		
		if(cod_model==null) throw new RuntimeException("Missing required parameter 'cod_model'");
		if(cod_report==null) throw new RuntimeException("Missing required parameter 'cod_report'");
		if(is_default==null) valuesMap.is_default = 0;
		
		String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE cod_report='"+cod_report+"' AND is_default=1";
		def res = services.queryService.executeQuery(query, null)[0];
		if(res==null) valuesMap.is_default = 1;
		
		return true;
	};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_report_model - afterInsert()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: gwr_r_report_model - beforeUpdate()");
		
		Integer is_default = valuesMap.is_default;
		if(is_default==1){
			String query = "UPDATE "+CLASS_TABLE_NAME+" SET is_default=0 WHERE 1=1";
			services.queryService.executeUpdateQuery(query, null);
		}else if(is_default==0){
			def id_r_report_model = oldvaluesMap.id_r_report_model;
			String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE is_default=1 and id_r_report_model <> '"+id_r_report_model+"'";
			def res = services.queryService.executeQuery(query, null)[0];
			if(res==null){
				def message = "Deve rimanere almeno un modello di default";
				//this.clientMessage = "Deve rimanere almeno un modello di default";
				throw new GwGroovyException(message);
			}
		}
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: gwr_r_report_model - afterUpdate()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_report_model - beforeDelete()");
		
		def id_r_report_model = valuesMap.id_r_report_model;
		String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE id_r_report_model="+id_r_report_model+"";
		def res = services.queryService.executeQuery(query, null)[0];
		if(res!=null) valuesMap.cod_report = res.cod_report;
		
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: gwr_r_report_model - afterDelete()");
		
		String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE cod_report='"+valuesMap.cod_report+"' AND is_default=1";
		def res = services.queryService.executeQuery(query, null)[0];
		if(res==null){
			//SET AT LEAST ONE DEFAULT MODEL, IF POSSIBLE
			Environment environment = applicationContext.getBean(Environment.class);
			if(environment!=null){
				String[] profiles = environment.getActiveProfiles();
				ArrayList<String> profilesList = new ArrayList<String>(Arrays.asList(profiles));
				//checking the db profile in context.xml at <Environment name="spring.profiles.active" value="oracle" description="" type="java.lang.String"/>
				if(profilesList.contains("oracle")){
					query = "SELECT cod_model FROM "+CLASS_TABLE_NAME+" WHERE cod_report='"+cod_report+"' FETCH FIRST 1 ROWS ONLY";
				}else if(profilesList.contains("postgres")){
					query = "SELECT cod_model FROM "+CLASS_TABLE_NAME+" WHERE cod_report='"+cod_report+"' LIMIT 1";
				}else if(profilesList.contains("sqlserver")){
					query = "SELECT TOP 1 cod_model FROM "+CLASS_TABLE_NAME+" WHERE cod_report='"+cod_report+"'";
				}
				query = "UPDATE "+CLASS_TABLE_NAME+" SET is_default=1 WHERE cod_report='"+cod_report+"' AND cod_model IN ("+query+")";
				services.queryService.executeUpdateQuery(query, null);
			}
		}
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};

} 