//@@@
//user:    GSC
//date:    25/01/2024
//ver:     4.6.0
//project: TEST 4.6.0
//type:    event trigger (TRIGGER DI CLASSE)
//class:   gwr_report_category
//note:    gwr_report_category event trigger
//@@@

import org.springframework.core.env.Environment;
import com.geowebframework.transfer.objects.exception.*;
	

public class GwrReportCategoryEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	private final String CLASS_NAME = "gwr_report_category";
	private final String CLASS_TABLE_NAME = CLASS_NAME;
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeInsert()");
		
		String radix = "EXP_REP_CAT_";
		String cod = "cod_report_category";
		Integer leadingZeros = 6;
		String leadedInt = String.format("%0"+leadingZeros+"d", 1);
		String query = "SELECT "+cod+" FROM "+CLASS_TABLE_NAME+" ORDER BY "+cod+" asc";
		def res = services.queryService.executeQuery(query, null);
		if(res.size()!=0){
			String cod_model_last = res[res.size()-1][cod];
			Integer lastInt = Integer.parseInt(cod_model_last.substring(cod_model_last.indexOf(radix)+radix.length()));
			lastInt++;
			leadedInt = String.format("%0"+leadingZeros+"d", lastInt);
		}
		String newCod = radix+leadedInt;
		valuesMap[cod] = newCod;
		
		
		String queryCount = "SELECT COUNT(*) FROM "+CLASS_TABLE_NAME;
		Integer count = services.queryService.executeCountQuery(queryCount, null);
		valuesMap.ord_report_category = ++count;
		
		return true;
		};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterInsert()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeUpdate()");
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterUpdate()");
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeDelete()");
		
		/*def id_report_category = valuesMap.id_report_category;
		String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE id_report_category="+id_report_category+"";
		def res = services.queryService.executeQuery(query, null)[0];
		if(res!=null) valuesMap.cod_report_category = res.cod_report_category;*/
		
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterDelete()");
		
		/*String query = "DELETE FROM gwr_r_rep_cat_func WHERE cod_report_category='"+valuesMap.cod_report_category+"'";
		def res = services.queryService.executeDeleteQuery(query, null);*/
		
		services.gwMetadataCacheService.clearAllStartingWith("gwExportableReportService_");
		
		return true;
	};

} 