//@@@
//user:    GSC
//date:    06/02/2024
//ver:     4.6.0
//project: TEST 4.6.0
//type:    event trigger (TRIGGER DI CLASSE)
//class:   gwr_param
//note:    gwr_param event trigger
//@@@

import org.springframework.core.env.Environment;
import com.geowebframework.transfer.objects.exception.*;
	

public class GwrReportParamEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	private final String CLASS_NAME = "gwr_param";
	private final String CLASS_TABLE_NAME = CLASS_NAME;
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeInsert()");
		
		String radix = "EXP_REP_PARAM_";
		String cod = "cod_report_param";
		Integer leadingZeros = 6;
		String leadedInt = String.format("%0"+leadingZeros+"d", 1);
		String query = "SELECT "+cod+" FROM "+CLASS_TABLE_NAME+" ORDER BY "+cod+" asc";
		def res = services.queryService.executeQuery(query, null);
		if(res.size()!=0){
			String cod_model_last = res[res.size()-1][cod];
			Integer lastInt = Integer.parseInt(cod_model_last.substring(cod_model_last.indexOf(radix)+radix.length()));
			lastInt++;
			leadedInt = String.format("%0"+leadingZeros+"d", lastInt);
		}
		String newCod = radix+leadedInt;
		valuesMap[cod] = newCod;
		
		return true;
		
		return true;
	};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterInsert()");
		
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeUpdate()");
		
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterUpdate()");
		
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeDelete()");
		
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterDelete()");
		
		return true;
	};

} 